org.apache.tinkerpop.gremlin.process.traversal.step.filter

## Class RangeGlobalStep<S>

- java.lang.Object
- - org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep<S,S>
  - - org.apache.tinkerpop.gremlin.process.traversal.step.filter.FilterStep<S>
    - - org.apache.tinkerpop.gremlin.process.traversal.step.filter.RangeGlobalStep<S>

- All Implemented Interfaces:
    Serializable, Cloneable, Iterator<Traverser.Admin<S>>, Step<S,S>, Barrier<TraverserSet<S>>, Bypassing, MemoryComputing<TraverserSet<S>>, Ranging

      public final class RangeGlobalStep<S>
      extends FilterStep<S>
      implements Ranging, Bypassing, Barrier<TraverserSet<S>>

  Author:
    Bob Briody (http://bobbriody.com), Marko A. Rodriguez (http://markorodriguez.com)
  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `RangeGlobalStep.RangeBiOperator<S>`

  - ### Field Summary

    - ### Fields inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `id, labels, nextEnd, nextStep, previousStep, starts, traversal, traverserStepIdAndLabelsSetByChild`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `RangeGlobalStep(Traversal.Admin traversal, long low, long high)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addBarrier(TraverserSet<S> barrier)` Add a barrier to the step.
    `RangeGlobalStep<S>` | `clone()` Cloning is used to duplicate steps for the purpose of traversal optimization and OLTP replication.
    `boolean` | `equals(Object other)`
    `protected boolean` | `filter(Traverser.Admin<S> traverser)`
    `long` | `getHighRange()`
    `long` | `getLowRange()`
    `MemoryComputeKey<TraverserSet<S>>` | `getMemoryComputeKey()` The `MemoryComputeKey` that will be used by this step.
    `Set<TraverserRequirement>` | `getRequirements()` Provide the necessary `TraverserRequirement` that must be met by the traverser in order for the step to function properly.
    `int` | `hashCode()`
    `boolean` | `hasNextBarrier()` Whether or not the step has an accessible barrier.
    `TraverserSet<S>` | `nextBarrier()` Get the next barrier within this step.
    `void` | `processAllStarts()` Process all left traversers by do not yield the resultant output.
    `void` | `reset()` Reset the state of the step such that it has no incoming starts.
    `void` | `setBypass(boolean bypass)`
    `String` | `toString()`

    - ### Methods inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.filter.FilterStep

      `processNextStart`

    - ### Methods inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `addLabel, addStart, addStarts, getId, getLabels, getNextStep, getPreviousStep, getStarts, getTraversal, hasNext, hasStarts, isTraverserStepIdAndLabelsSetByChild, next, prepareTraversalForNextStep, removeLabel, setId, setNextStep, setPreviousStep, setTraversal`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.Barrier

      `done`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.Step

      `equals`

    - ### Methods inherited from interface java.util.Iterator

      `forEachRemaining, remove`

- - ### Constructor Detail

    - #### RangeGlobalStep

          public RangeGlobalStep(Traversal.Admin traversal,
                                 long low,
                                 long high)

  - ### Method Detail

    - #### filter

          protected boolean filter(Traverser.Admin<S> traverser)

      Specified by:
        `filter` in class `FilterStep<S>`

    - #### reset

          public void reset()

      Description copied from interface: `Step`
      Reset the state of the step such that it has no incoming starts. Internal states are to be reset, but any sideEffect data structures are not to be recreated.
      Specified by:
        `reset` in interface `Step<S,S>`
      Overrides:
        `reset` in class `AbstractStep<S,S>`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `AbstractStep<S,S>`

    - #### getLowRange

          public long getLowRange()

      Specified by:
        `getLowRange` in interface `Ranging`

    - #### getHighRange

          public long getHighRange()

      Specified by:
        `getHighRange` in interface `Ranging`

    - #### clone

          public RangeGlobalStep<S> clone()

      Description copied from interface: `Step`
      Cloning is used to duplicate steps for the purpose of traversal optimization and OLTP replication. When cloning a step, it is important that the steps, the cloned step is equivalent to the state of the step when `Step.reset()` is called. Moreover, the previous and next steps should be set to `EmptyStep`.
      Specified by:
        `clone` in interface `Step<S,S>`
      Overrides:
        `clone` in class `AbstractStep<S,S>`
      Returns:
        The cloned step

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `AbstractStep<S,S>`

    - #### equals

          public boolean equals(Object other)

      Overrides:
        `equals` in class `AbstractStep<S,S>`

    - #### getRequirements

          public Set<TraverserRequirement> getRequirements()

      Description copied from interface: `Step`
      Provide the necessary `TraverserRequirement` that must be met by the traverser in order for the step to function properly. The provided default implements returns an empty set.
      Specified by:
        `getRequirements` in interface `Step<S,S>`
      Returns:
        the set of requirements

    - #### getMemoryComputeKey

          public MemoryComputeKey<TraverserSet<S>> getMemoryComputeKey()

      Description copied from interface: `MemoryComputing`
      The `MemoryComputeKey` that will be used by this step.
      Specified by:
        `getMemoryComputeKey` in interface `MemoryComputing<TraverserSet<S>>`
      Returns:
        the MemoryComputeKey to use

    - #### setBypass

          public void setBypass(boolean bypass)

      Specified by:
        `setBypass` in interface `Bypassing`

    - #### processAllStarts

          public void processAllStarts()

      Description copied from interface: `Barrier`
      Process all left traversers by do not yield the resultant output. This method is useful for steps like `ReducingBarrierStep`, where traversers can be processed "on the fly" and thus, reduce memory consumption.
      Specified by:
        `processAllStarts` in interface `Barrier<TraverserSet<S>>`

    - #### hasNextBarrier

          public boolean hasNextBarrier()

      Description copied from interface: `Barrier`
      Whether or not the step has an accessible barrier.
      Specified by:
        `hasNextBarrier` in interface `Barrier<TraverserSet<S>>`
      Returns:
        whether a barrier exists or not

    - #### nextBarrier

          public TraverserSet<S> nextBarrier()
                                      throws NoSuchElementException

      Description copied from interface: `Barrier`
      Get the next barrier within this step. Barriers from parallel steps can be the be merged to create a single step with merge barriers.
      Specified by:
        `nextBarrier` in interface `Barrier<TraverserSet<S>>`
      Returns:
        the next barrier of the step
      Throws:
        `NoSuchElementException`

    - #### addBarrier

          public void addBarrier(TraverserSet<S> barrier)

      Description copied from interface: `Barrier`
      Add a barrier to the step. This typically happens when multiple parallel barriers need to become one barrier at a single step.
      Specified by:
        `addBarrier` in interface `Barrier<TraverserSet<S>>`
      Parameters:
        `barrier` - the barrier to merge in

Copyright © 2013–2022 Apache Software Foundation. All rights reserved.